﻿using System.Windows;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 펜
        /// </summary>
        private Pen pen;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.pen = new Pen(Brushes.Blue, 10);

            this.pen.Freeze();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 렌더링시 처리하기 - OnRender(drawingContext)

        /// <summary>
        /// 렌더링시 처리하기
        /// </summary>
        /// <param name="drawingContext">그리기 컨텍스트</param>
        protected override void OnRender(DrawingContext drawingContext)
        {
            drawingContext.DrawRectangle
            (
                Brushes.White,
                null,
                new Rect
                (
                    0,
                    0,
                    this.grid.ActualWidth,
                    this.grid.ActualHeight
                )
            );

            EllipseGeometry ellipseGeometry = new EllipseGeometry();

            ellipseGeometry.Center  = new Point(this.grid.ActualWidth / 2, this.grid.ActualHeight / 2);
            ellipseGeometry.RadiusX = 200;
            ellipseGeometry.RadiusY = 200;

            drawingContext.DrawGeometry(Brushes.Red, this.pen, ellipseGeometry);
        }

        #endregion
    }
}